# ------------------------------------------------------------------------------------------------------------
# Copyright (c) 2024 Gunivers
#
# This file is part of the Bookshelf project (https://github.com/Gunivers/Bookshelf).
#
# This source code is subject to the terms of the Mozilla Public License, v. 2.0.
# If a copy of the MPL was not distributed with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
#
# Conditions:
# - You may use this file in compliance with the MPL v2.0
# - Any modifications must be documented and disclosed under the same license
#
# For more details, refer to the MPL v2.0.
#
# Documentation of the feature: https://bookshelf.docs.gunivers.net/en/latest/modules/math.html#pow
# ------------------------------------------------------------------------------------------------------------

# pow(x,y) = exp2(y * log2(x))
data modify storage bs:ctx x set from storage bs:in math.pow.x
data modify storage bs:ctx y set from storage bs:in math.pow.y

function bs.math:frexp/run
function bs.math:log2/fract with storage bs:ctx
scoreboard players operation #math.frexp.e bs.data *= 16777216 bs.const
function bs.math:pow/mul with storage bs:ctx

execute store result score #math.ldexp.e bs.data store result score #math.exp2.x bs.data run data get storage bs:ctx x
function bs.math:exp2/run
data modify storage bs:out math.pow set from storage bs:ctx x
